package org.antlr.tool;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import org.antlr.tool.ErrorManager;

public class Attribute {
  public String decl;
  
  public String type;
  
  public String name;
  
  public String initValue;
  
  public Attribute(String decl) {
    extractAttribute(decl);
  }
  
  public Attribute(String name, String decl) {
    this.name = name;
    this.decl = decl;
  }
  
  protected void extractAttribute(String decl) {
    if (decl == null)
      return; 
    boolean inID = false;
    int start = -1;
    int rightEdgeOfDeclarator = decl.length() - 1;
    int equalsIndex = decl.indexOf('=');
    if (equalsIndex > 0) {
      this.initValue = decl.substring(equalsIndex + 1, decl.length());
      rightEdgeOfDeclarator = equalsIndex - 1;
    } 
    for (int i = rightEdgeOfDeclarator; i >= 0; i--) {
      if (!inID && Character.isLetterOrDigit(decl.charAt(i))) {
        inID = true;
      } else if (inID && !Character.isLetterOrDigit(decl.charAt(i)) && decl.charAt(i) != '_') {
        start = i + 1;
        break;
      } 
    } 
    if (start < 0 && inID)
      start = 0; 
    if (start < 0)
      ErrorManager.error(104, decl); 
    int stop = -1;
    for (int j = start; j <= rightEdgeOfDeclarator; j++) {
      if (!Character.isLetterOrDigit(decl.charAt(j)) && decl.charAt(j) != '_') {
        stop = j;
        break;
      } 
      if (j == rightEdgeOfDeclarator)
        stop = j + 1; 
    } 
    this.name = decl.substring(start, stop);
    this.type = decl.substring(0, start);
    if (stop <= rightEdgeOfDeclarator)
      this.type += decl.substring(stop, rightEdgeOfDeclarator + 1); 
    this.type = this.type.trim();
    if (this.type.length() == 0)
      this.type = null; 
    this.decl = decl;
  }
  
  public String toString() {
    if (this.initValue != null)
      return this.type + " " + this.name + "=" + this.initValue; 
    return this.type + " " + this.name;
  }
}
